
RVBMenuHelperFrame = {}
local v_u_1 = Class(RVBMenuHelperFrame, TabbedMenuFrameElement)
local function v_u_2() end
RVBMenuHelperFrame.SUB_CATEGORY = {
	["GAME_SETTINGS"] = 1,
	["GENERAL_SETTINGS"] = 2
}
function RVBMenuHelperFrame.register()
	local v3 = RVBMenuHelperFrame.new()
	g_gui:loadGui(g_vehicleBreakdownsDirectory .. "gui/RVBMenuHelperFrame.xml", "SettingsFrame", v3, true)
end
function RVBMenuHelperFrame.new(p4, p5)
	local v6 = TabbedMenuFrameElement.new(p4, p5 or v_u_1)
	v6.missionInfo = nil
	v6.RVB = nil
	v6.hasMasterRights = false
	v6.isOpening = false
	return v6
end
function RVBMenuHelperFrame.createFromExistingGui(p11, p12)
	local v13 = RVBMenuHelperFrame.new()
	g_gui.frames[p11.name].target:delete()
	g_gui.frames[p11.name]:delete()
	g_gui:loadGui(p11.xmlFilename, p12, v13, true)
	return v13
end
function RVBMenuHelperFrame.initialize(p_u_14)
	p_u_14:initializeSubCategoryPages()
	p_u_14:initializeGameSettings()
	p_u_14:initializeGeneralSettings()
	p_u_14:initializeButtons()
	p_u_14.subCategoryPagingFocusChangeFunc = p_u_14.subCategoryPaging.shouldFocusChange
end
function RVBMenuHelperFrame.initializeSubCategoryPages(p_u_24)
	local v25 = {}
	for v_u_26, v27 in pairs(p_u_24.subCategoryTabs) do
		v27:getDescendantByName("background").getIsSelected = function()
			local v28 = v_u_26
			local v29 = p_u_24.subCategoryPaging.texts[p_u_24.subCategoryPaging:getState()]
			return v28 == tonumber(v29)
		end
		function v27.getIsSelected()
			local v30 = v_u_26
			local v31 = p_u_24.subCategoryPaging.texts[p_u_24.subCategoryPaging:getState()]
			return v30 == tonumber(v31)
		end
		local v32 = g_currentMission
		if v_u_26 == RVBMenuHelperFrame.SUB_CATEGORY.SERVER_SETTINGS and not (p_u_24.hasMasterRights and v32.missionDynamicInfo.isMultiplayer) then
			v27:setVisible(false)
		else
			v27:setVisible(true)
			local v33 = tostring(v_u_26)
			table.insert(v25, v33)
		end
	end
	p_u_24.subCategoryBox:invalidateLayout()
	p_u_24.subCategoryPaging:setTexts(v25)
	p_u_24.subCategoryPaging:setSize(p_u_24.subCategoryBox.maxFlowSize + 140 * g_pixelSizeScaledX)
end
function RVBMenuHelperFrame.initializeGameSettings(p_u_34, p35, p36)
	p_u_34:assignStaticTexts()
	p_u_34.onClickBackCallback = p36 or v_u_2
end
function RVBMenuHelperFrame.initializeGeneralSettings(self)
	local difficultyTable = {}
	table.insert(difficultyTable, g_i18n:getText(RVBMenuHelperFrame.L10N_SYMBOL.DIFFICULTY_SLOW))
	table.insert(difficultyTable, g_i18n:getText(RVBMenuHelperFrame.L10N_SYMBOL.DIFFICULTY_MEDIUM))
	table.insert(difficultyTable, g_i18n:getText(RVBMenuHelperFrame.L10N_SYMBOL.DIFFICULTY_FAST))
	self.multiRvbDifficulty:setTexts(difficultyTable)
end
function RVBMenuHelperFrame.initializeButtons(p_u_39)
	p_u_39.backButtonInfo = {
		["inputAction"] = InputAction.MENU_BACK
	}
	p_u_39.nextPageButtonInfo = {
		["inputAction"] = InputAction.MENU_PAGE_NEXT,
		["text"] = g_i18n:getText("ui_ingameMenuNext"),
		["callback"] = p_u_39.onPageNext
	}
	p_u_39.prevPageButtonInfo = {
		["inputAction"] = InputAction.MENU_PAGE_PREV,
		["text"] = g_i18n:getText("ui_ingameMenuPrev"),
		["callback"] = p_u_39.onPagePrevious
	}
	p_u_39.resetButtonInfo = {
		["inputAction"] = InputAction.MENU_CANCEL,
		["text"] = g_i18n:getText(RVBMenuHelperFrame.L10N_SYMBOL.BUTTON_DEFAULTS),
		["callback"] = function()
			p_u_39:onClickDefaults()
		end,
		["showWhenPaused"] = true
	}
end
function RVBMenuHelperFrame.setMissionInfo(p42, p43)
	p42.missionInfo = p43

end
function RVBMenuHelperFrame.setHasMasterRights(p47, p48)
	p47.hasMasterRights = p48
	if g_currentMission ~= nil then
		p47:updateButtons()
	end
end
function RVBMenuHelperFrame.onFrameOpen(p49, _)
	RVBMenuHelperFrame:superClass().onFrameOpen(p49)
	p49:initializeSubCategoryPages()
	p49.isOpening = true
	local v50 = g_currentMission
	local v51 = v50.missionDynamicInfo.isMultiplayer
	if not v51 or (v51 and g_inGameMenu.isServer or g_inGameMenu.isMasterUser) then
		p49:updateGameSettings()
		p49.gameSettingsLayout:setVisible(true)
		p49.gameSettingsLayout:invalidateLayout()
		p49.gameSettingsSeparator:setVisible(true)
		p49.gameSettingsNoPermissionText:setVisible(false)
	else
		p49.gameSettingsLayout:setVisible(false)
		p49.gameSettingsSeparator:setVisible(false)
		p49.gameSettingsNoPermissionText:setVisible(true)
	end
	p49:updateGeneralSettings()
	local v59 = true
	for _, v60 in pairs(p49.gameSettingsLayout.elements) do
		if v60.name == "sectionHeader" then
			v59 = true
		elseif v60:getIsVisible() then
			local v61 = RVBMenuHelperFrame.COLOR_ALTERNATING[v59]
			v60:setImageColor(nil, unpack(v61))
			v59 = not v59
		end
	end
	local v62 = true
	for _, v63 in pairs(p49.generalSettingsLayout.elements) do
		if v63.name == "sectionHeader" then
			v62 = true
		elseif v63:getIsVisible() then
			local v64 = RVBMenuHelperFrame.COLOR_ALTERNATING[v62]
			v63:setImageColor(nil, unpack(v64))
			v62 = not v62
		end
	end
	p49.generalSettingsLayout:invalidateLayout()
	p49:updateSubCategoryPages((p49.subCategoryPaging:getState()))
	p49.isOpening = false
end
function RVBMenuHelperFrame.onFrameClose(p76)
	--g_settingsModel:saveChanges(SettingsModel.SETTING_CLASS.SAVE_GAMEPLAY_SETTINGS)
	RVBMenuHelperFrame:superClass().onFrameClose(p76)
end
function RVBMenuHelperFrame.update(p77, p78)
	RVBMenuHelperFrame:superClass().update(p77, p78)
	if p77.nextFocusSection ~= nil then
		local v79 = p77.controlsList:getElementAtSectionIndex(p77.nextFocusSection, p77.nextFocusCell)
		if v79 ~= nil then
			local v80 = v79:getAttribute(p77.nextFocusedButtonName)
			FocusManager:setFocus(v80)
			p77.nextFocusSection = nil
			p77.nextFocusCell = nil
		end
	end
end
function RVBMenuHelperFrame.updateButtons(p97)
	p97.menuButtonInfo = { p97.backButtonInfo, p97.nextPageButtonInfo, p97.prevPageButtonInfo }
	--local v98 = p97.subCategoryPaging.texts[p97.subCategoryPaging:getState()]
	p97:setMenuButtonInfoDirty()
end
function RVBMenuHelperFrame.updateGameSettings(self)
	local RVB = g_currentMission.vehicleBreakdowns
	self.multidailyServiceInterval:setState(rvb_Utils.getDailyServiceIndex(RVB:getDailyService(), 2))
	self.multiperiodicServiceInterval:setState(rvb_Utils.getPeriodicServiceIndex(RVB:getPeriodicService(), 1))
	--self.checkonlyWorkshop:setIsChecked(RVB:getIsRepairShop(), self.isOpening)
	self.multiworkshopOpen:setState(rvb_Utils.getWorkshopOpenIndex(RVB:getWorkshopOpen(), 1))
	self.multiworkshopClose:setState(rvb_Utils.getWorkshopCloseIndex(RVB:getWorkshopClose(), 1))
	self.multiThermostatLifetime:setState(rvb_Utils.getLargeLifetimeIndex(RVB:getThermostatLifetime(), 30))
	self.multiLightingsLifetime:setState(rvb_Utils.getLargeLifetimeIndex(RVB:getLightingsLifetime(), 44))
	self.multiGlowplugLifetime:setState(rvb_Utils.getSmallLifetimeIndex(RVB:getGlowplugLifetime(), 2))
	self.multiWipersLifetime:setState(rvb_Utils.getLargeLifetimeIndex(RVB:getWipersLifetime(), 16))
	self.multiGeneratorLifetime:setState(rvb_Utils.getLargeLifetimeIndex(RVB:getGeneratorLifetime(), 36))
	self.multiEngineLifetime:setState(rvb_Utils.getLargeLifetimeIndex(RVB:getEngineLifetime(), 42))
	self.multiSelfstarterLifetime:setState(rvb_Utils.getSmallLifetimeIndex(RVB:getSelfstarterLifetime(), 3))
	self.multiBatteryLifetime:setState(rvb_Utils.getLargeLifetimeIndex(RVB:getBatteryLifetime(), 28))
	self.multiTireLifetime:setState(rvb_Utils.getLargeLifetimeIndex(RVB:getTireLifetime(), 68))
end
function RVBMenuHelperFrame.assignStaticTexts(self)
	self:assignDailyServiceTexts()
	self:assignPeriodicServiceTexts()
	self:assignWorkshopOpenTexts()
	self:assignWorkshopCloseTexts()
	self:assignThermostatLifetimeTexts()
	self:assignLightingsLifetimeTexts()
	self:assignGlowplugLifetimeTexts()
	self:assignWipersLifetimeTexts()
	self:assignGeneratorLifetimeTexts()
	self:assignEngineLifetimeTexts()
	self:assignSelfstarterLifetimeTexts()
	self:assignBatteryLifetimeTexts()
	self:assignTireLifetimeTexts()
end
function RVBMenuHelperFrame.assignDailyServiceTexts(self)
	local dailyServiceTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.DailyService) do
		local dailyServiceStrings = rvb_Utils.getDailyServiceString
		table.insert(dailyServiceTable, dailyServiceStrings(i))
	end
	self.multidailyServiceInterval:setTexts(dailyServiceTable)
	-- deactivate
	self.multidailyServiceInterval:setDisabled(true)
	self.multidailyServiceInterval:setVisible(true)
end
function RVBMenuHelperFrame.assignPeriodicServiceTexts(self)
	local periodicServiceTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.PeriodicService) do
		local periodicServiceStrings = rvb_Utils.getPeriodicServiceString
		table.insert(periodicServiceTable, periodicServiceStrings(i))
	end
	self.multiperiodicServiceInterval:setTexts(periodicServiceTable)
end
function RVBMenuHelperFrame.assignWorkshopOpenTexts(self)
	local workshopOpenTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.WorkshopOpen) do
		local workshopOpenStrings = rvb_Utils.getWorkshopOpenString
		table.insert(workshopOpenTable, workshopOpenStrings(i))
	end
	self.multiworkshopOpen:setTexts(workshopOpenTable)
end
function RVBMenuHelperFrame.assignWorkshopCloseTexts(self)
	local workshopCloseTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.WorkshopClose) do
		local workshopCloseStrings = rvb_Utils.getWorkshopCloseString
		table.insert(workshopCloseTable, workshopCloseStrings(i))
	end
	self.multiworkshopClose:setTexts(workshopCloseTable)
end
function RVBMenuHelperFrame.assignThermostatLifetimeTexts(self)
	local thermostatLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.LargeArray) do
		local largeLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(thermostatLifetimeTable, largeLifetimeStrings(i))
	end
	self.multiThermostatLifetime:setTexts(thermostatLifetimeTable)
end
function RVBMenuHelperFrame.assignLightingsLifetimeTexts(self)
	local lightingsLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.LargeArray) do
		local largeLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(lightingsLifetimeTable, largeLifetimeStrings(i))
	end
	self.multiLightingsLifetime:setTexts(lightingsLifetimeTable)
end
function RVBMenuHelperFrame.assignGlowplugLifetimeTexts(self)
	local glowplugLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.SmallArray) do
		local smallLifetimeStrings = rvb_Utils.getSmallLifetimeString
		table.insert(glowplugLifetimeTable, smallLifetimeStrings(i))
	end
	self.multiGlowplugLifetime:setTexts(glowplugLifetimeTable)
end
function RVBMenuHelperFrame.assignWipersLifetimeTexts(self)
	local wipersLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.LargeArray) do
		local largeLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(wipersLifetimeTable, largeLifetimeStrings(i))
	end
	self.multiWipersLifetime:setTexts(wipersLifetimeTable)
end
function RVBMenuHelperFrame.assignGeneratorLifetimeTexts(self)
	local generatorLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.LargeArray) do
		local largeLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(generatorLifetimeTable, largeLifetimeStrings(i))
	end
	self.multiGeneratorLifetime:setTexts(generatorLifetimeTable)
end
function RVBMenuHelperFrame.assignEngineLifetimeTexts(self)
	local engineLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.LargeArray) do
		local largeLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(engineLifetimeTable, largeLifetimeStrings(i))
	end
	self.multiEngineLifetime:setTexts(engineLifetimeTable)
end
function RVBMenuHelperFrame.assignSelfstarterLifetimeTexts(self)
	local selfstarterLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.SmallArray) do
		local smallLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(selfstarterLifetimeTable, smallLifetimeStrings(i))
	end
	self.multiSelfstarterLifetime:setTexts(selfstarterLifetimeTable)
end
function RVBMenuHelperFrame.assignBatteryLifetimeTexts(self)
	local batteryLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.LargeArray) do
		local largeLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(batteryLifetimeTable, largeLifetimeStrings(i))
	end
	self.multiBatteryLifetime:setTexts(batteryLifetimeTable)
end
function RVBMenuHelperFrame.assignTireLifetimeTexts(self)
	local tireLifetimeTable = {}
	for i = 1, rvb_Utils.table_count(rvb_Utils.LargeArray) do
		local largeLifetimeStrings = rvb_Utils.getLargeLifetimeString
		table.insert(tireLifetimeTable, largeLifetimeStrings(i))
	end
	self.multiTireLifetime:setTexts(tireLifetimeTable)
end
function RVBMenuHelperFrame.updateGeneralSettings(self)
	local RVB = g_currentMission.vehicleBreakdowns
	self.checkAlertDialog:setIsChecked(RVB:getIsAlertMessage(), self.isOpening)
	self.multiRvbDifficulty:setState(RVB:getRVBDifficulty())
	self.checkRVBDebug:setIsChecked(RVB:getIsDebugDisplay(), self.isOpening)
	self.checkshowTemp:setIsChecked(RVB:getIsShowTempDisplay(), self.isOpening)
	self.checkshowRpm:setIsChecked(RVB:getIsShowRpmDisplay(), self.isOpening)
	self.checkshowFuel:setIsChecked(RVB:getIsShowFuelDisplay(), self.isOpening)
end
function RVBMenuHelperFrame.onClickPeriodicServiceInterval(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setPeriodicServiceInterval(rvb_Utils.getPeriodicServiceFromIndex(state))
	end
end
--function RVBMenuSettingsFrame.onClickOnlyWorkshop(self, _, elements)
--	if self.hasMasterRights then
--		g_currentMission.vehicleBreakdowns:setIsRepairShop(elements:getIsChecked())
--	end
--end
function RVBMenuHelperFrame.onClickWorkshopOpen(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setWorkshopOpen(rvb_Utils.getWorkshopOpenFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickWorkshopClose(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setWorkshopClose(rvb_Utils.getWorkshopCloseFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickThermostatLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setThermostatLifetime(rvb_Utils.getLargeLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickLightingsLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setLightingsLifetime(rvb_Utils.getLargeLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickGlowplugLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setGlowplugLifetime(rvb_Utils.getSmallLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickWipersLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setWipersLifetime(rvb_Utils.getLargeLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickGeneratorLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setGeneratorLifetime(rvb_Utils.getLargeLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickEngineLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setEngineLifetime(rvb_Utils.getLargeLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickSelfstarterLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setSelfstarterLifetime(rvb_Utils.getSmallLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickBatteryLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setBatteryLifetime(rvb_Utils.getLargeLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickTireLifetime(self, state)
	if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setTireLifetime(rvb_Utils.getLargeLifetimeFromIndex(state))
	end
end
function RVBMenuHelperFrame.onClickAlertDialog(self, _, elements)
	--if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setIsAlertMessage(elements:getIsChecked())
	--end
end
function RVBMenuHelperFrame.onClickRvbDifficulty(self, state)
	--if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setRVBDifficulty(state)
	--end
end
function RVBMenuHelperFrame.onClickRVBDebug(self, _, elements)
	--if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setIsDebugDisplay(elements:getIsChecked())
	--end
end
function RVBMenuHelperFrame.onClickshowTemp(self, _, elements)
	--if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setIsShowTempDisplay(elements:getIsChecked())
	--end
end
function RVBMenuHelperFrame.onClickshowRpm(self, _, elements)
	--if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setIsShowRpmDisplay(elements:getIsChecked())
	--end
end
function RVBMenuHelperFrame.onClickshowFuel(self, _, elements)
	--if self.hasMasterRights then
		g_currentMission.vehicleBreakdowns:setIsShowFuelDisplay(elements:getIsChecked())
	--end
end
function RVBMenuHelperFrame.onClickGameSettings(p266)
	p266.subCategoryPaging:setState(RVBMenuHelperFrame.SUB_CATEGORY.GAME_SETTINGS, true)
end
function RVBMenuHelperFrame.onClickGeneralSettings(p267)
	p267.subCategoryPaging:setState(RVBMenuHelperFrame.SUB_CATEGORY.GENERAL_SETTINGS, true)
end
function RVBMenuHelperFrame.onClickPreviousSubCategory(p270)
	p270.subCategoryPaging:onLeftButtonClicked()
end
function RVBMenuHelperFrame.onClickNextSubCategory(p271)
	p271.subCategoryPaging:onRightButtonClicked()
end
function RVBMenuHelperFrame.updateSubCategoryPages(p_u_272, p_u_273)
	local v274 = p_u_272.subCategoryPaging.texts[p_u_273]
	if v274 == nil then
		return
	else
		local v275 = tonumber(v274)
		if p_u_272:requestClose(function()
			p_u_272:updateSubCategoryPages(p_u_273)
		end) then
			for v276, v277 in pairs(p_u_272.subCategoryPages) do
				v277:setVisible(v276 == v275)
			end
			p_u_272.subCategoryPaging.shouldFocusChange = p_u_272.subCategoryPagingFocusChangeFunc
			p_u_272.categoryHeaderIcon:setImageSlice(nil, RVBMenuHelperFrame.HEADER_SLICES[v275])
			p_u_272.categoryHeaderText:setText(g_i18n:getText(RVBMenuHelperFrame.HEADER_TITLES[v275]))
			if p_u_272.menuAcceptUpEventId ~= nil then
				g_inputBinding:removeActionEvent(p_u_272.menuAcceptUpEventId)
			end
			if v275 == RVBMenuHelperFrame.SUB_CATEGORY.GAME_SETTINGS then
				p_u_272.settingsSlider:setDataElement(p_u_272.gameSettingsLayout)
				FocusManager:linkElements(p_u_272.subCategoryPaging, FocusManager.TOP, p_u_272.gameSettingsLayout.elements[#p_u_272.gameSettingsLayout.elements].elements[1])
				FocusManager:linkElements(p_u_272.subCategoryPaging, FocusManager.BOTTOM, p_u_272.gameSettingsLayout.elements[1].elements[1])
			elseif v275 == RVBMenuHelperFrame.SUB_CATEGORY.GENERAL_SETTINGS then
				p_u_272.settingsSlider:setDataElement(p_u_272.generalSettingsLayout)
				FocusManager:linkElements(p_u_272.subCategoryPaging, FocusManager.TOP, p_u_272.generalSettingsLayout.elements[#p_u_272.generalSettingsLayout.elements].elements[1])
				FocusManager:linkElements(p_u_272.subCategoryPaging, FocusManager.BOTTOM, p_u_272.generalSettingsLayout.elements[1].elements[1])
			end
			p_u_272:updateButtons()
			FocusManager:setFocus(p_u_272.subCategoryPaging)
		end
	end
end
function RVBMenuHelperFrame.inputEvent(p324, p325, _, p326)
	if p325 == InputAction.MENU_ACCEPT then
		return FocusManager:getFocusedElement() ~= p324.buttonPauseGame
	else
		return p326
	end
end
function RVBMenuHelperFrame.onClickDefaults(p_u_337)
	YesNoDialog.show(function(p338)
		if p338 then
			p_u_337:updateButtons()
			InfoDialog.show(g_i18n:getText(SettingsControlsFrame.L10N_SYMBOL.DEFAULTS_LOADED), function(p339)
				p339.nextFocusSection = 1
				p339.nextFocusCell = 1
				p339.nextFocusedButtonName = "actionButton1"
			end, p_u_337, DialogElement.TYPE_INFO)
		end
	end, nil, g_i18n:getText(RVBMenuHelperFrame.L10N_SYMBOL.LOAD_DEFAULTS), g_i18n:getText(RVBMenuHelperFrame.L10N_SYMBOL.BUTTON_RESET))
end

RVBMenuHelperFrame.L10N_SYMBOL = {
	["DIFFICULTY_SLOW"] = "RVB_difficulty_slow",
	["DIFFICULTY_MEDIUM"] = "RVB_difficulty_medium",
	["DIFFICULTY_FAST"] = "RVB_difficulty_fast",
	["BUTTON_DEFAULTS"] = "button_defaults",
	["LOAD_DEFAULTS"] = "ui_loadDefaultSettings",
	["DEFAULTS_LOADED"] = "ui_loadedDefaultSettings",
	["BUTTON_RESET"] = "button_reset"
}
RVBMenuHelperFrame.HEADER_SLICES = {
	[RVBMenuHelperFrame.SUB_CATEGORY.GAME_SETTINGS] = "gui.icon_options_gameSettings2",
	[RVBMenuHelperFrame.SUB_CATEGORY.GENERAL_SETTINGS] = "gui.icon_options_generalSettings2"
}
RVBMenuHelperFrame.HEADER_TITLES = {
	[RVBMenuHelperFrame.SUB_CATEGORY.GAME_SETTINGS] = "ui_ingameMenuGameSettingsGame",
	[RVBMenuHelperFrame.SUB_CATEGORY.GENERAL_SETTINGS] = "ui_ingameMenuGameSettingsGeneral"
}
RVBMenuHelperFrame.COLOR_ALTERNATING = {
	[true] = {
		0.02956,
		0.02956,
		0.02956,
		0.6
	},
	[false] = {
		0.02956,
		0.02956,
		0.02956,
		0.2
	}
}
RVBMenuHelperFrame.COLOR = {
	["BLACK"] = {
		0.00439,
		0.00478,
		0.00368,
		1
	},
	["GREEN"] = {
		0.22323,
		0.40724,
		0.00368,
		1
	}
}